| The Gaudi Framework v32r1 (f65d50dc)

Classes | Public Types | Public Member Functions | Private Member Functions | Private Attributes | List of all members
ReplayOutputStream Class Reference

`#include <component/ReplayOutputStream.h>`

Inheritance diagram for ReplayOutputStream:
[legend]
Collaboration diagram for ReplayOutputStream:
[legend]

## Classes
class | OutStreamAdder
| Helper class to fill the internal map of OutputStreams. More...

## Public Types
typedef GaudiUtils::HashMap< std::string, SmartIF< IAlgorithm > > | OutStreamsMapType
| Class used to hold the OutputStream instances. More...

## Public Member Functions
StatusCode | initialize () override
| Algorithm initialization. More...
StatusCode | start () override
| Algorithm initialization. More...
StatusCode | execute () override
| Algorithm execution. More...
StatusCode | stop () override
| Algorithm finalization. More...
StatusCode | finalize () override
| Algorithm finalization. More...
| GaudiAlgorithm (const std::string &name, ISvcLocator *pSvcLocator)
| Inherited constructor. More...
| GaudiAlgorithm (const GaudiAlgorithm &)=delete
| Inherited constructor. More...
Public Member Functions inherited from GaudiAlgorithm
StatusCode | initialize () override
| standard initialization method More...
StatusCode | execute () override
| standard execution method More...
StatusCode | finalize () override
| standard finalization method More...
StatusCode | sysExecute (const EventContext &ctx) override
| the generic actions for the execution. More...
void | put (IDataProviderSvc *svc, DataObject *object, const std::string &address, const bool useRootInTES=true) const
| Register a data object or container into Gaudi Event Transient Store. More...
void | put (IDataProviderSvc *svc, std::unique_ptr< DataObject > object, const std::string &address, const bool useRootInTES=true) const
const DataObject * | put (DataObject *object, const std::string &address, const bool useRootInTES=true) const
| Register a data object or container into Gaudi Event Transient Store. More...
const DataObject * | put (std::unique_ptr< DataObject > object, const std::string &address, const bool useRootInTES=true) const
template<class TYPE >
Gaudi::Utils::GetData< TYPE >::return_type | get (IDataProviderSvc *svc, const std::string &location, const bool useRootInTES=true) const
| Templated access to the data in Gaudi Transient Store. More...
template<class TYPE >
Gaudi::Utils::GetData< TYPE >::return_type | getIfExists (IDataProviderSvc *svc, const std::string &location, const bool useRootInTES=true) const
| Templated access to the data in Gaudi Transient Store. More...
template<class TYPE >
Gaudi::Utils::GetData< TYPE >::return_type | get (const std::string &location, const bool useRootInTES=true) const
| Templated access to the data from Gaudi Event Transient Store. More...
template<class TYPE >
Gaudi::Utils::GetData< TYPE >::return_type | getIfExists (const std::string &location, const bool useRootInTES=true) const
| Templated access to the data in Gaudi Transient Store. More...
template<class TYPE >
TYPE * | getDet (IDataProviderSvc *svc, const std::string &location) const
| Templated access to the detector data from the Gaudi Detector Transient Store. More...
template<class TYPE >
Gaudi::Utils::GetData< TYPE >::return_type | getDetIfExists (IDataProviderSvc *svc, const std::string &location) const
| Templated access to the detector data from the Gaudi Detector Transient Store. More...
template<class TYPE >
TYPE * | getDet (const std::string &location) const
| Templated access to the detector data from the Gaudi Detector Transient Store. More...
template<class TYPE >
Gaudi::Utils::GetData< TYPE >::return_type | getDetIfExists (const std::string &location) const
| Templated access to the detector data from the Gaudi Detector Transient Store. More...
template<class TYPE >
bool | exist (IDataProviderSvc *svc, const std::string &location, const bool useRootInTES=true) const
| Check the existence of a data object or container in the Gaudi Transient Event Store. More...
template<class TYPE >
bool | exist (const std::string &location, const bool useRootInTES=true) const
| Check the existence of a data object or container in the Gaudi Transient Event Store. More...
template<class TYPE >
bool | existDet (IDataProviderSvc *svc, const std::string &location) const
| Check the existence of detector objects in the Gaudi Transient Detector Store. More...
template<class TYPE >
bool | existDet (const std::string &location) const
| Check the existence of detector objects in the Gaudi Transient Detector Store. More...
template<class TYPE , class TYPE2 >
Gaudi::Utils::GetData< TYPE >::return_type | getOrCreate (IDataProviderSvc *svc, const std::string &location, const bool useRootInTES=true) const
| Get the existing data object from Gaudi Event Transient store. More...
template<class TYPE , class TYPE2 >
Gaudi::Utils::GetData< TYPE >::return_type | getOrCreate (const std::string &location, const bool useRootInTES=true) const
| Get the existing data object from Gaudi Event Transient store. More...
| GaudiAlgorithm (const std::string &name, ISvcLocator *pSvcLocator)
| Standard constructor. More...
| GaudiAlgorithm (const GaudiAlgorithm &)=delete
GaudiAlgorithm & | operator= (const GaudiAlgorithm &)=delete
SmartIF< INTupleSvc > & | evtColSvc () const
| Access the standard event collection service. More...
Public Member Functions inherited from GaudiCommon< Algorithm >
Gaudi::Utils::GetData< TYPE >::return_type | get (IDataProviderSvc *svc, const std::string &location, const bool useRootInTES=true) const
| Templated access to the data in Gaudi Transient Store. More...
Gaudi::Utils::GetData< TYPE >::return_type | getIfExists (IDataProviderSvc *svc, const std::string &location, const bool useRootInTES=true) const
| Quicker version of the get function which bypasses the check on the retrieved data. More...
bool | exist (IDataProviderSvc *svc, const std::string &location, const bool useRootInTES=true) const
| Check the existence of a data object or container in the Gaudi Transient Event Store. More...
Gaudi::Utils::GetData< TYPE >::return_type | getOrCreate (IDataProviderSvc *svc, const std::string &location, const bool useRootInTES=true) const
| Get the existing data object from Gaudi Event Transient store. More...
DataObject * | put (IDataProviderSvc *svc, std::unique_ptr< DataObject > object, const std::string &location, const bool useRootInTES=true) const
| Register a data object or container into Gaudi Event Transient Store. More...
DataObject * | put (IDataProviderSvc *svc, DataObject *object, const std::string &location, const bool useRootInTES=true) const
TOOL * | tool (const std::string &type, const std::string &name, const IInterface *parent=0, bool create=true) const
| Useful method for the easy location of tools. More...
TOOL * | tool (const std::string &type, const IInterface *parent=0, bool create=true) const
| A useful method for the easy location of tools. More...
SmartIF< SERVICE > | svc (const std::string &name, const bool create=true) const
| A useful method for the easy location of services. More...
IUpdateManagerSvc * | updMgrSvc () const
| Short-cut to locate the Update Manager Service. More...
WARN_UNUSED StatusCode | Error (const std::string &msg, const StatusCode st=StatusCode::FAILURE, const size_t mx=10) const
| Print the error message and return with the given StatusCode. More...
WARN_UNUSED StatusCode | Warning (const std::string &msg, const StatusCode st=StatusCode::FAILURE, const size_t mx=10) const
| Print the warning message and return with the given StatusCode. More...
WARN_UNUSED StatusCode | Info (const std::string &msg, const StatusCode st=StatusCode::SUCCESS, const size_t mx=10) const
| Print the info message and return with the given StatusCode. More...
WARN_UNUSED StatusCode | Print (const std::string &msg, const StatusCode st=StatusCode::SUCCESS, const MSG::Level lev=MSG::INFO) const
| Print the message and return with the given StatusCode. More...
void | Assert (const bool ok, const std::string &message="", const StatusCode sc=StatusCode(StatusCode::FAILURE, true)) const
| Assertion - throw exception if the given condition is not fulfilled. More...
void | Assert (const bool ok, const char *message, const StatusCode sc=StatusCode(StatusCode::FAILURE, true)) const
| Assertion - throw exception if the given condition is not fulfilled. More...
void | Exception (const std::string &msg, const GaudiException &exc, const StatusCode sc=StatusCode(StatusCode::FAILURE, true)) const
| Create and (re)-throw a given GaudiException. More...
void | Exception (const std::string &msg, const std::exception &exc, const StatusCode sc=StatusCode(StatusCode::FAILURE, true)) const
| Create and (re)-throw a given exception. More...
void | Exception (const std::string &msg="no message", const StatusCode sc=StatusCode(StatusCode::FAILURE, true)) const
| Create and throw an exception with the given message. More...
StatEntity & | counter (const std::string &tag) const
| accessor to certain counter by name More...
StatEntity & | counter (const std::string &tag)
bool | typePrint () const
| Insert the actual C++ type of the algorithm/tool in the messages ? More...
bool | propsPrint () const
| Print properties at initialization ? More...
bool | statPrint () const
| Print statistical counters at finalization ? More...
bool | errorsPrint () const
| Print error counters at finalization ? More...
long | printStat (const MSG::Level level=MSG::ALWAYS) const
| perform the actual printout of statistical counters More...
long | printErrors (const MSG::Level level=MSG::ALWAYS) const
| perform the actual printout of error counters More...
long | printProps (const MSG::Level level=MSG::ALWAYS) const
| perform the actual printout of properties More...
void | registerCondition (const std::string &condition, StatusCode(CallerClass::*mf)()=nullptr)
| register the current instance to the UpdateManagerSvc as a consumer for a condition. More...
void | registerCondition (const std::string &condition, CondType *&condPtrDest, StatusCode(CallerClass::*mf)()=NULL)
| register the current instance to the UpdateManagerSvc as a consumer for a condition. More...
void | registerCondition (char *condition, StatusCode(CallerClass::*mf)()=NULL)
| just to avoid conflicts with the version using a pointer to a template class. More...
void | registerCondition (TargetClass *condition, StatusCode(CallerClass::*mf)()=NULL)
| register the current instance to the UpdateManagerSvc as a consumer for a condition. More...
StatusCode | runUpdate ()
| asks the UpdateManagerSvc to perform an update of the instance (if needed) without waiting the next BeginEvent incident. More...
| GaudiCommon (const std::string &name, ISvcLocator *pSvcLocator)
| Algorithm constructor - the SFINAE constraint below ensures that this is constructor is only defined if PBASE derives from Algorithm. More...
| GaudiCommon (const std::string &type, const std::string &name, const IInterface *ancestor)
| Tool constructor - SFINAE-ed to insure this constructor is only defined if PBASE derives from AlgTool. More...
StatusCode | initialize () override
| standard initialization method More...
StatusCode | finalize () override
| standard finalization method More...
StatusCode | release (const IInterface *interface) const
| Manual forced (and 'safe') release of the active tool or service. More...
const Services & | services () const
| get the list of aquired services More...
const std::string & | context () const
| Returns the "context" string. Used to identify different processing states. More...
Public Member Functions inherited from FixTESPath< BASE >
template<typename U = BASE, typename = std::enable_if_t<std::is_base_of_v<Gaudi::Algorithm, BASE>, U>>
| FixTESPath (const std::string &name, ISvcLocator *pSvcLocator)
| Algorithm constructor - the SFINAE constraint below ensures that this is constructor is only defined if BASE derives from Algorithm. More...
template<typename U = BASE, typename = std::enable_if_t<std::is_base_of_v<AlgTool, BASE>, U>>
| FixTESPath (const std::string &type, const std::string &name, const IInterface *ancestor)
| Tool constructor - SFINAE-ed to insure this constructor is only defined if BASE derives from AlgTool. More...
StatusCode | initialize () override
const std::string & | rootInTES () const
| Returns the "rootInTES" string. More...
std::string | fullTESLocation (std::string_view location, bool useRootInTES) const
| Returns the full correct event location given the rootInTes settings. More...

## Private Member Functions
void | i_addOutputStream (const Gaudi::Utils::TypeNameString &outStream)
| Add a new algorithm to the list of OutputStreams. More...
template<Gaudi::StateMachine::Transition TR>
StatusCode | i_outStreamTransition ()
| Helper function to call the transition on the contained OutputStreams. More...

## Private Attributes
Gaudi::Property< std::vector< std::string > > | m_outputStreamNames
OutStreamsMapType | m_outputStreams
| Internal storage for the OutputStreams to call. More...
SmartIF< IAlgManager > | m_algMgr
SmartIF< IDataManagerSvc > | m_evtMgr

## Additional Inherited Members
Protected Types inherited from GaudiCommon< Algorithm >
using | base_class = FixTESPath< Algorithm >
typedef std::map< std::string, StatEntity > | StatisticsOwn
| the actual type of general counters More...
typedef std::map< std::string, std::reference_wrapper< Gaudi::Accumulators::PrintableCounter > > | Statistics
typedef std::map< std::string, unsigned int > | Counter
| the actual type error/warning counter More...
typedef std::vector< IAlgTool * > | AlgTools
| storage for active tools More...
typedef std::vector< SmartIF< IService > > | Services
| storage for active services More...
Protected Member Functions inherited from GaudiCommon< Algorithm >
StatusCode | releaseTool (const IAlgTool *tool) const
| manual forced (and 'safe') release of the tool More...
StatusCode | releaseSvc (const IInterface *svc) const
| manual forced (and 'safe') release of the service More...
Protected Attributes inherited from GaudiCommon< Algorithm >
SmartIF< ICounterSummarySvc > | m_counterSummarySvc
| a pointer to the CounterSummarySvc More...
Static Protected Attributes inherited from GaudiCommon< Algorithm >
static const bool | IgnoreRootInTES
| Simple definition to be used with the new useRootInTES argument get<TYPE> and put methods. More...
static const bool | UseRootInTES
| Simple definition to be used with the new useRootInTES argument get<TYPE> and put methods. More...

## Detailed Description

Author
  Marco Clemencic

Date
  30/08/2013

Definition at line 19 of file ReplayOutputStream.h.

## Member Typedef Documentation

## ◆ OutStreamsMapType

typedef GaudiUtils::HashMap<std::string, SmartIF<IAlgorithm> > ReplayOutputStream::OutStreamsMapType

Class used to hold the OutputStream instances.

Definition at line 31 of file ReplayOutputStream.h.

## Member Function Documentation

## ◆ execute()

StatusCode ReplayOutputStream::execute | ( |  | ) |
| override

Algorithm execution.

Definition at line 112 of file ReplayOutputStream.cpp.

112 {
113 if ( msgLevel( MSG::DEBUG ) ) debug() << "==> Execute" << endmsg;
114
115 std::vector<std::string> names;
116 m_evtMgr->traverseSubTree( RecordOutputStream::locationRoot(), [&names]( IRegistry* pReg, int lvl ) {
117 if ( lvl > 0 ) names.push_back( pReg->name() );
118 return true;
119 } );
120
121 std::for_each( names.begin(), names.end(), [this]( const std::string& name ) {
122 SmartIF<IAlgorithm>& alg = this->m_outputStreams[name];
123 if ( alg ) {
124 const auto& ctx = Gaudi::Hive::currentContext();
125 if ( alg->execState( ctx ).state() != AlgExecState::State::Done ) {
126 alg->sysExecute( ctx );
127 } else {
128 this->warning() << name << " already executed for the current event" << endmsg;
129 }
130 } else {
131 this->warning() << "invalid OuputStream " << name << endmsg;
132 }
133 } );
134
135 return StatusCode::SUCCESS;
136 }
SmartIF< IAlgorithm >
ManySmallAlgs.alg
alg
Definition: ManySmallAlgs.py:69
gaudiComponentHelp.name
name
Definition: gaudiComponentHelp.py:41
ReplayOutputStream::m_outputStreams
OutStreamsMapType m_outputStreams
Internal storage for the OutputStreams to call.
Definition: ReplayOutputStream.h:56
IDataManagerSvc::traverseSubTree
virtual StatusCode traverseSubTree(std::string_view sub_tree_path, IDataStoreAgent *pAgent)=0
Analyse by traversing all data objects below the sub tree identified by its full path name.
MSG::DEBUG
Definition: IMessageSvc.h:15
StatusCode::SUCCESS
constexpr static const auto SUCCESS
Definition: StatusCode.h:85
IRegistry::name
virtual const name_type & name() const =0
Name of the directory (or key)
std::vector::end
T end(T... args)
std::string
STL class.
std::vector::push_back
T push_back(T... args)
Gaudi::Hive::currentContext
GAUDI_API const EventContext & currentContext()
Definition: ThreadLocalContext.cpp:20
IRegistry
The IRegistry represents the entry door to the environment any data object residing in a transient da...
Definition: IRegistry.h:22
std::vector< std::string >
std::vector::begin
T begin(T... args)
ReplayOutputStream::m_evtMgr
SmartIF< IDataManagerSvc > m_evtMgr
Definition: ReplayOutputStream.h:59
std::for_each
T for_each(T... args)
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:192
RecordOutputStream::locationRoot
static const std::string locationRoot()
Return the path in the Transient Store used to record the triggered instances.
Definition: RecordOutputStream.h:30

## ◆ finalize()

StatusCode ReplayOutputStream::finalize | ( |  | ) |
| override

Algorithm finalization.

Definition at line 141 of file ReplayOutputStream.cpp.

141 {
142 if ( msgLevel( MSG::DEBUG ) ) debug() << "==> Finalize" << endmsg;
143
144 StatusCode sc = i_outStreamTransition<Gaudi::StateMachine::FINALIZE>();
145
146 // release interfaces
147 m_outputStreams.clear();
148 m_algMgr.reset();
149 m_evtMgr.reset();
150
151 StatusCode fsc = GaudiAlgorithm::finalize(); // must be called after all other actions
152 if ( sc.isSuccess() ) sc = fsc;
153 return sc;
154 }
ReplayOutputStream::m_outputStreams
OutStreamsMapType m_outputStreams
Internal storage for the OutputStreams to call.
Definition: ReplayOutputStream.h:56
MSG::DEBUG
Definition: IMessageSvc.h:15
StatusCode
This class is used for returning status codes from appropriate routines.
Definition: StatusCode.h:50
GaudiAlgorithm::finalize
StatusCode finalize() override
standard finalization method
Definition: GaudiAlgorithm.cpp:55
StatusCode::isSuccess
bool isSuccess() const
Definition: StatusCode.h:267
GaudiUtils::Map::clear
void clear()
Definition: Map.h:185
SmartIF::reset
void reset(TYPE *ptr=nullptr)
Set the internal pointer to the passed one disposing of the old one.
Definition: SmartIF.h:86
ReplayOutputStream::m_evtMgr
SmartIF< IDataManagerSvc > m_evtMgr
Definition: ReplayOutputStream.h:59
ReplayOutputStream::m_algMgr
SmartIF< IAlgManager > m_algMgr
Definition: ReplayOutputStream.h:58
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:192

## ◆ GaudiAlgorithm() [1/2]

GaudiAlgorithm::GaudiAlgorithm
| delete

Inherited constructor.

## ◆ GaudiAlgorithm() [2/2]

GaudiAlgorithm::GaudiAlgorithm

Inherited constructor.

Definition at line 35 of file GaudiAlgorithm.cpp.

36 : GaudiCommon<Algorithm>( name, pSvcLocator ) {
37 setProperty( "RegisterForContextService", true ).ignore();
38 }
gaudiComponentHelp.name
name
Definition: gaudiComponentHelp.py:41
setProperty
bool PyHelper() setProperty(IInterface *p, char *name, char *value)
Definition: Bootstrap.cpp:233
GaudiCommon< Algorithm >

## ◆ i_addOutputStream()

void ReplayOutputStream::i_addOutputStream | ( | const Gaudi::Utils::TypeNameString & | outStream | ) |
| private

Add a new algorithm to the list of OutputStreams.

Definition at line 166 of file ReplayOutputStream.cpp.

166 {
167 // we prepend '/' to the name of the algorithm to simplify the handling in
168 // OutputStreamsCollector
169 const std::string algId = "/" + outStream.name();
170 if ( m_outputStreams.find( algId ) == m_outputStreams.end() ) {
171 m_outputStreams[algId] = m_algMgr->algorithm( outStream );
172 if ( !m_outputStreams[algId] ) {
173 throw GaudiException( name(), "Could not get algorithm " + outStream.name(), StatusCode::FAILURE );
174 }
175 } else {
176 warning() << "OutputStream instance " << outStream.name() << " already added, ignoring " << outStream << endmsg;
177 }
178 }
IAlgManager::algorithm
virtual SmartIF< IAlgorithm > & algorithm(const Gaudi::Utils::TypeNameString &typeName, const bool createIf=true)=0
Returns a smart pointer to a service.
GaudiException
Define general base for Gaudi exception.
Definition: GaudiException.h:21
gaudiComponentHelp.name
name
Definition: gaudiComponentHelp.py:41
ReplayOutputStream::m_outputStreams
OutStreamsMapType m_outputStreams
Internal storage for the OutputStreams to call.
Definition: ReplayOutputStream.h:56
std::string
STL class.
GaudiUtils::Map::end
iterator end()
Definition: Map.h:130
Gaudi::Utils::TypeNameString::name
const std::string & name() const
Definition: TypeNameString.h:37
GaudiUtils::Map::find
iterator find(const key_type &key)
Definition: Map.h:147
StatusCode::FAILURE
constexpr static const auto FAILURE
Definition: StatusCode.h:86
ReplayOutputStream::m_algMgr
SmartIF< IAlgManager > m_algMgr
Definition: ReplayOutputStream.h:58
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:192

## ◆ i_outStreamTransition()

template<Gaudi::StateMachine::Transition TR>

StatusCode ReplayOutputStream::i_outStreamTransition | ( |  | ) |
| private

Helper function to call the transition on the contained OutputStreams.

Returns StatusCode::FAILURE if any of the OutputStreams returned a failure.

Definition at line 74 of file ReplayOutputStream.cpp.

74 {
75 OutStreamTransition<TR> trans( msg() );
76 std::for_each( m_outputStreams.begin(), m_outputStreams.end(), trans );
77 return trans.result();
78 }
ReplayOutputStream::m_outputStreams
OutStreamsMapType m_outputStreams
Internal storage for the OutputStreams to call.
Definition: ReplayOutputStream.h:56
GaudiUtils::Map::end
iterator end()
Definition: Map.h:130
GaudiUtils::Map::begin
iterator begin()
Definition: Map.h:129
GaudiMP.FdsRegistry.msg
msg
Definition: FdsRegistry.py:8
std::for_each
T for_each(T... args)

## ◆ initialize()

StatusCode ReplayOutputStream::initialize | ( |  | ) |
| override

Algorithm initialization.

Definition at line 83 of file ReplayOutputStream.cpp.

83 {
84 StatusCode sc = GaudiAlgorithm::initialize(); // must be executed first
85 if ( sc.isFailure() ) return sc; // error printed already by GaudiAlgorithm
86
87 if ( msgLevel( MSG::DEBUG ) ) debug() << "==> Initialize" << endmsg;
88
89 m_algMgr = service( "ApplicationMgr" );
90 if ( UNLIKELY( !m_algMgr ) ) return Error( "cannot retrieve IAlgManager" );
91
92 m_evtMgr = evtSvc();
93 if ( UNLIKELY( !m_evtMgr ) ) return Error( "cannot retrieve IDataManagerSvc " );
94
95 std::for_each( m_outputStreamNames.begin(), m_outputStreamNames.end(), OutStreamAdder( this ) );
96
97 return i_outStreamTransition<Gaudi::StateMachine::INITIALIZE>();
98 }
UNLIKELY
#define UNLIKELY(x)
Definition: Kernel.h:96
GaudiAlgorithm::initialize
StatusCode initialize() override
standard initialization method
Definition: GaudiAlgorithm.cpp:42
MSG::DEBUG
Definition: IMessageSvc.h:15
GaudiCommon< Algorithm >::Error
WARN_UNUSED StatusCode Error(const std::string &msg, const StatusCode st=StatusCode::FAILURE, const size_t mx=10) const
Print the error message and return with the given StatusCode.
Definition: GaudiCommon.icpp:286
ReplayOutputStream::m_outputStreamNames
Gaudi::Property< std::vector< std::string > > m_outputStreamNames
Definition: ReplayOutputStream.h:52
StatusCode
This class is used for returning status codes from appropriate routines.
Definition: StatusCode.h:50
StatusCode::isFailure
bool isFailure() const
Definition: StatusCode.h:130
ReplayOutputStream::m_evtMgr
SmartIF< IDataManagerSvc > m_evtMgr
Definition: ReplayOutputStream.h:59
std::for_each
T for_each(T... args)
ReplayOutputStream::m_algMgr
SmartIF< IAlgManager > m_algMgr
Definition: ReplayOutputStream.h:58
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:192

## ◆ start()

StatusCode ReplayOutputStream::start | ( |  | ) |
| override

Algorithm initialization.

Definition at line 100 of file ReplayOutputStream.cpp.

100 {
101 StatusCode sc = GaudiAlgorithm::start(); // must be executed first
102 if ( sc.isFailure() ) return sc; // error printed already by GaudiAlgorithm
103
104 if ( msgLevel( MSG::DEBUG ) ) debug() << "==> Start" << endmsg;
105
106 return i_outStreamTransition<Gaudi::StateMachine::START>();
107 }
MSG::DEBUG
Definition: IMessageSvc.h:15
IOTest.start
def start
Definition: IOTest.py:97
StatusCode
This class is used for returning status codes from appropriate routines.
Definition: StatusCode.h:50
StatusCode::isFailure
bool isFailure() const
Definition: StatusCode.h:130
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:192

## ◆ stop()

StatusCode ReplayOutputStream::stop | ( |  | ) |
| override

Algorithm finalization.

Definition at line 156 of file ReplayOutputStream.cpp.

156 {
157 if ( msgLevel( MSG::DEBUG ) ) debug() << "==> Stop" << endmsg;
158
159 StatusCode sc = i_outStreamTransition<Gaudi::StateMachine::STOP>();
160
161 StatusCode ssc = GaudiAlgorithm::stop(); // must be called after all other actions
162 if ( sc.isSuccess() ) sc = ssc;
163 return sc;
164 }
MSG::DEBUG
Definition: IMessageSvc.h:15
StatusCode
This class is used for returning status codes from appropriate routines.
Definition: StatusCode.h:50
StatusCode::isSuccess
bool isSuccess() const
Definition: StatusCode.h:267
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:192

## Member Data Documentation

## ◆ m_algMgr

SmartIF<IAlgManager> ReplayOutputStream::m_algMgr
| private

Definition at line 58 of file ReplayOutputStream.h.

## ◆ m_evtMgr

SmartIF<IDataManagerSvc> ReplayOutputStream::m_evtMgr
| private

Definition at line 59 of file ReplayOutputStream.h.

## ◆ m_outputStreamNames

Gaudi::Property<std::vector<std::string> > ReplayOutputStream::m_outputStreamNames
| private

Initial value:
{
this, "OutputStreams", {}, "OutputStream instances that can be called."}

Definition at line 52 of file ReplayOutputStream.h.

## ◆ m_outputStreams

OutStreamsMapType ReplayOutputStream::m_outputStreams
| private

Internal storage for the OutputStreams to call.

Definition at line 56 of file ReplayOutputStream.h.

The documentation for this class was generated from the following files:

- GaudiMP/src/component/ReplayOutputStream.h
- GaudiMP/src/component/ReplayOutputStream.cpp